<template>
  <div class="container">
    <h1>Creando cuenta...</h1>
    <p v-if="redirect">necesitas iniciar sesión para ir acá :)</p>
    <custom-form
      :fields="fields"
      :handleSubmit="handleSubmit"
      :parseError="parseError"
    />
    <small>
      <router-link :to="iniciarSesionPath">¿ya tenés una cuenta?</router-link>
    </small>
  </div>
</template>

<script>
import CustomForm from '@/components/Form'

export default {
  name: 'CrearCuentaView',
  data() {
    return {
      fields: [
        { name: 'nick', placeholder: 'Nickname', required: true, type: 'text' },
        {
          name: 'email',
          placeholder: 'Dirección de e-mail',
          required: true,
          type: 'email',
        },
        {
          name: 'password',
          placeholder: 'Contraseña',
          required: true,
          minLength: 8,
          type: 'password',
        },
        { type: 'submit', content: 'Crear cuenta' },
      ],
    }
  },
  components: {
    CustomForm,
  },
  computed: {
    redirect() {
      return this.$route.query.redirect
    },
    iniciarSesionPath() {
      return `/iniciarSesion${
        this.redirect ? '?redirect=' + encodeURIComponent(this.redirect) : ''
      }`
    },
  },
  methods: {
    handleSubmit(userData) {
      return this.$store
        .dispatch('crearCuenta', userData)
        .then(res => this.$router.replace(this.redirect || '/'))
    },
    parseError: error => error, // probablemente no pase ningun error generico
  },
}
</script>
